/*
	NUMERICKE METODY I

	Hledani realnych korenu polynomu U(u)=0

	Autor:Jan Schee, jan.schee@fpf.slu.cz

*/

#include <stdio.h>
#include <math.h>

double g_a, g_l,g_q;

double f(double x)
{
	double x2,U;
	double a2,l2,q;

	x2=x*x;
	a2=g_a*g_a;
	l2=g_l*g_l;
	q=g_q;

	U= 1 + x2*( a2-l2-q + x*( 2*((g_a-g_l)*(g_a-g_l) + q) - a2*q*x ) );

	return U;

}


double midpoint(double a, double b, double eps)
{
	double m;
	double fa,fb,fm;
	
	while(fabs(a-b)>eps)
	{
		m=0.5*(a+b);
		fm=f(m);
		
		fa=f(a);
		fb=f(b);

		if(fa*fm<0) b=m;
		else a=m;				
	}

	return m;
}


double secna(double a, double b, double eps)
{
	double m;
	double fa,fb,fm;
	
	m=0.5*(a+b);
	fm=f(m);

	while(fabs(a-b)>eps && fabs(fm)>eps )
	{
		m=0.5*(a+b);

		fm=f(m);
		
		fa=f(a);
		fb=f(b);

		if(fa*fm<0) b=m;
		else a=m;				
	}

	return m;
}



int bracketing(double xmin, double xmax, double xl[], double xu[],int n)
{
	int i,j;	
	double dx,x1,x2;

	j=0;//indexuje podintervaly na kterych lezi koren rce U=0

	dx=(xmax-xmin)/n;
	
	for(i=0;i<n;i++)
	{
		x1=xmin+i*dx;
		x2=x1+dx;

		if(f(x1)*f(x2)<0)
		{
			xl[j]=x1;
			xu[j]=x2;
			j++;
		}
	}
	
	return j;
}



int main()
{
	double umin,umax,eps;
	int i,n,cnt;
	double ul[4];
	double uu[4];	
	double ut[4];

	printf("zadej parametry a, l , q:");
	scanf("%lf %lf %lf",&g_a,&g_l,&g_q);

	umin=0.0;

	umax=1+sqrt(1-g_a*g_a);
	umax=1/umax;

	n=1000;
	eps=1e-8;

	cnt=bracketing(umin,umax,ul,uu,n);

	for(i=0;i<cnt;i++){
		ut[i]=secna(ul[i],uu[i],eps);	
		printf("[%d] %lf in [%lf, %lf]  (%lf)\n",i,ut[i],ul[i],uu[i],f(ut[i]));
	
	}
		
		
	return 0;
}

